<?php
########## Simple defaults and checks ##########
error_reporting( E_ALL );
if(phpversion() < 5){ echo 'PHP satisfied with the version '.phpversion().' not the requirement'; exit;}
header( "Content-Type: text/html; charset=utf-8" );

########## Define merchant account ##########
define('MERCHANT_USERNAME','psc_payout_test'); //username
define('MERCHANT_PASSWORD','nYDiP9z7BnHRM'); //password
define('PRODUCTIVE',false); //productive or test
define('UTC_OFFSET','+01:00'); //UTC Offset
define('DEMO_ACCOUNT_FILE','customer-list.csv'); //File with demo customer accounts
if(!@is_file(DEMO_ACCOUNT_FILE)){die('No '.DEMO_ACCOUNT_FILE.' CSV-file found!');} //check the demo account file

########## STEP CONTROLLER ##########
if(isset($_POST['submit']))
{
    $result = step2();
    if(!$result)
    {
        step1();
    }
    else
    {
        echo '<div style="position:absolute; top:0; left:0; width:75%; height:70%; overflow:scroll; background-color:#ECEFF4;"><h1 style="margin:30px;">Customer</h1>';
        echo customerDetailPage($result);
        echo '</div>';
        echo '<div style="position:absolute; top:0; right:0; width:25%; height:100%; background-color:#DAD6D6;">';
        echo '<h1 style="margin:30px;">Merchant</h1>';
        echo ($result['result'])?getConfirmButton($_POST['email'],$_POST['amount'],$_POST['currency']):'';
        echo '</div>';
        echo '<div style="position:absolute; bottom:0; left:0; width:75%; height:30%; overflow:scroll; background-color:#E3DDDD;"><h1 style="margin:30px;">Debug</h1>';
        echo '<pre style="margin-left:30px;">';var_dump($result['details']);echo'</pre></div>'; 
    }
    
}
if(isset($_POST['confirm']))
{
    $result = step3();
    echo '<div style="position:absolute; top:0; left:0; width:75%; height:70%; overflow:scroll; background-color:#ECEFF4;"><h1 style="margin:30px;">Customer</h1>';
    echo step1();
    echo '</div>';
    echo '<div style="position:absolute; top:0; right:0; width:25%; height:100%; background-color:#DAD6D6;">';
    echo '<h1 style="margin:30px;">Merchant</h1>';
    echo ($result['result'])?'Success':'Fail';
    echo '</div>';
    echo '<div style="position:absolute; bottom:0; left:0; width:75%; height:30%; overflow:scroll; background-color:#E3DDDD;"><h1 style="margin:30px;">Debug</h1>';
    echo '<pre style="margin-left:30px;">';var_dump($result['details']);echo'</pre></div>'; 
}
else
{
    echo step1();
}

########## THE 3 BASIC STEPS ##########
function step1()
{
    $currencys = loadDemoData('currencys'); //load the currencys
    return getForm($currencys); //show input form
}
function step2()
{    
    return doRequest(true); //pre-check payout
}
function step3()
{
    return doRequest(false); // payout
}
########## CLASS & REQUEST ##########
function doRequest($validateOnly)
{   
    include_once'payout.class.php';
    $class = new payout(MERCHANT_USERNAME,MERCHANT_PASSWORD,PRODUCTIVE);
    
    $amount = number_format((float)str_replace(',','.',$_POST['amount']),2);
    $email = trim($_POST['email']);    
    $account = loadDemoData('account',$email);
    //set details (Amount|Currency|PtId|utcOffset)
    $class->setTransaction($amount,$_POST['currency'],null,UTC_OFFSET);
    //set customer (merchantClientId|customerId|customerIdType)
    $class->setCustomer($account['customerNo'],$email,'EMAIL');
    //set customer details (firstName|lastName|dateOfBirth)
    $class->setCustomerDetails($account['firstName'],$account['lastName'],$account['dateOfBirth']); 
    $result = $class->payout($validateOnly);
    return array('result'=>$result,'details'=>$class->getDetails());
}
########## HTML OUTPUTS FOR DEMO ##########
function getForm($currencys)
{
    $form = '<form action="'.$_SERVER['PHP_SELF'].'" method="post">';
    $form .= '<input type="text" tabindex="1" name="email" title="E-Mail" placeholder="E-Mail" size="45" autofocus="autofocus" spellcheck="false" /><br /><br />';
    $form .= '<input type="text" tabindex="2" name="amount" title="Amount" placeholder="Amount" size="10" spellcheck="false" />';
    $form .= '<select tabindex="3" name="currency" title="Currency" size="1" >';   
    foreach($currencys as $entry)
    {$form .= '<option value="'.$entry.'">'.$entry.'</option>';}
    $form .= '</select><br /><br />';
    $form .= '<input type="submit" tabindex="4" title="Submit" value="Submit" name="submit" />';
    $form .= '</form>';
    return $form;
}
function getConfirmButton($email,$amount,$currency)
{
    $form = '<form action="'.$_SERVER['PHP_SELF'].'" method="post">';
    $form .= '<input type="hidden" name="email" value="'.$email.'" />';
    $form .= '<input type="hidden" name="amount" value="'.$amount.'" />';
    $form .= '<input type="hidden" name="currency" value="'.$currency.'" />';   
    $form .= '<input type="submit" tabindex="5" title="Confirm" value="Confirm" name="confirm" style="margin:30px auto; width:80px; display:block;" />';
    $form .= '</form>';
    return $form;
}
function customerDetailPage($result)
{
    if($result['result'])
    {
        $return = '<p style="margin:30px;">Thank you for your request!<br />';
        $return .= 'We are processing the payout of ';
        $return .= '<b>'.$result['details']['transaction']['amount'].' '.$result['details']['transaction']['currency'].'</b> ';
        if($result['details']['payoutResult']['transactionDetails']['requestedCurrency'] != $result['details']['payoutResult']['transactionDetails']['payedInCurrency'])
        {
            $return .= '('.number_format($result['details']['payoutResult']['transactionDetails']['payedAmount'],2).' '.$result['details']['payoutResult']['transactionDetails']['payedInCurrency'].') ';
        }                 
        $return .= 'to your my paysafecard account. This can take up to 7 working days.</p>';
        return $return;
    } 
    return '<p>'.$result['details']['payoutResult']['errorMsg'].'</p>';
}
########## DEMODATA ########## 
function loadDemoData($type="account",$email=null)
{   
    $handle = fopen( DEMO_ACCOUNT_FILE, 'r' );
    $account = $currencys = array();
    while ( ( $data = fgetcsv( $handle, 350, ',' ) ) !== false )
    {
        if($data[0]==null){continue;}
    	if ( !in_array( 'CURRENCY', $data ) )
    	{
    	   if($type != 'account')
            {if ( !in_array( $data[array_search('CURRENCY',$keys)], $currencys ) ) array_push($currencys,$data[array_search('CURRENCY',$keys)]);}
           elseif($email == null)
            {array_push($account,$data[array_search('EMAIL',$keys)]);} 
           elseif($email == $data[array_search('EMAIL',$keys)])
            {$account = array(
                'customerNo'=>$data[array_search('CUSTOMER_NO',$keys)],
                'firstName'=>$data[array_search('FIRST_NAME',$keys)],
                'lastName' => $data[array_search('LAST_NAME',$keys)],
                'dateOfBirth'=>date('Y-m-d',strtotime($data[array_search('BIRTHDATE',$keys)]))
                );
            }               
        }
        else
        {
            foreach ( $data as $key => $value )
            {
			     $keys[] = $value;
            }
        }
    }
    return ($type == 'account')?$account:$currencys;
}
